/* This is the STATUSL addon for sreLite 

Use /statusl? to invoke this addon.

*/

statusl:
parse arg  ddir, tempfile, reqstrg,list,verb ,uri,user, ,
          basedir ,workdir,privset,enmadd,transaction,verbose, ,
         servername,host_nickname,homedir,aparam,semqueue,prog_file,reqnum

/* aparam is obsoloete. Semqueue is semaphore/queue information
that can be used by some sre-daemon procedures */

if verb=" " then do
   say "This SRE-http procedure is not meant to be run in standalone mode "
   exit
end  /* Do */

list0=list
list=translate(list, ' ', '+'||'090a0d'x)  /* Whitespace, etc. */

/* first "parse" the parameter list, and store in a simple stem variable */
  m=0
  optname.=0
  do until list=""
    parse var list opt1 '&' list
    m=m+1
    parse var opt1 avar '=' aval ; avar=strip(translate(avar)) ; aval=strip(aval)
    if aval='' then aval=1
    avar='!'avar
    optname.avar=aval
  end


Srelite=VALUE('SRELITE_INIT',,'OS2ENVIRONMENT')

/* Information will be returned in a temporary file, whose name
is provided in the tempfile variable.
Note that it's a good idea to start your HTML documents with a dtd doctype statement
*/

call lineout tempfile, '<!doctype html public "-//IETF//DTD HTML 2.0//EN">'
call lineout tempfile, "<html><head><title>Results from a /statusl?  request</title>"
call lineout tempfile, "</head><body>"

if list0='' then do
        call lineout tempfile,' <h2>Results from  a /statusl? request </h2>'

        call lineout tempfile,' <h3>The arguments recieved by the statusl addon </h3> '

        call lineout tempfile,' <dl> '

        call lineout tempfile,' <dt>  DDIR = <code>' ddir '</code> '
        call lineout tempfile,' <dd>  The "data directory" (where your HTML documents should be) '
        call lineout tempfile,' <dt>  TEMPFILE = <code>' tempfile ' </code> '
        call lineout tempfile,' <dd> The "temporary file" (used to build this response)'

        call lineout tempfile,' <dt>  ACTION = <code>' reqstrg ' </code> '
        call lineout tempfile,' <dd>  The  <b>action</b> portion of the request selector'


        call lineout tempfile,' <dt>  LIST = <code>' list ' </code> '
        call lineout tempfile,' <dd> The <b>parameters</b>: '
        call lineout tempfile, '<br> ... if POST method, from the "body" of the request '
        call lineout tempfile,' <br> ... if GET method ,  from after the "?" in the request selector.  '

        call lineout tempfile,' <dt>  VERB = <code>' VERB ' </code> '
        call lineout tempfile,' <dd>  The HTTP method '
        call lineout tempfile,' <dt>  URI = <code>' URI ' </code> '
        call lineout tempfile,' <dd> The full <b>request string</b> '

        call lineout tempfile,' <dt> CLIENT = <code>' user ' </code> '
        call lineout tempfile," <dd> Client's ip address "

        call lineout tempfile,' <dt>  BASEDIR = <code>' basedir ' </code> '
        call lineout tempfile,' <dd> The "working directory" (where SRE-http lives) '

        call lineout tempfile,' <dt>  WORKDIR = <code>' workdir ' </code> '
        call lineout tempfile,' <dd>  Temporary working files area (for <em>user-supplied </em> programs ) '

        call lineout tempfile,' <Dt> Your privileges are: '
        call lineout tempfile,' <DD> <code> ' privset ' </code> '
 
        call lineout tempfile,' <Dt> The host nickname '
        call lineout tempfile,' <DD> <code> ' host_nickname ' </code> '

        call lineout tempfile, '<dt> The ~ (home directory) string '
        call lineout tempfile,' <Dd> <code> ' homedir  ' </code>'

        call lineout tempfile,' <dt> The program file '
        if prog_file=' ' then
          call lineout tempfile,' <dd><code> run from macrospace </code>'
        else
          call lineout tempfile,' <dd><code> ' prog_file '</code>'

        call lineout tempfile,'<dt>Transaction and request '
        call lineout tempfile,'<DD>' transaction ', 'reqnum
        call lineout tempfile,'</dl>'

/* Read the "header" -- and display the results */
       'READ HEADER VAR FOO '
         call lineout tempfile,' <h3> The Request Header </h3> '

        call lineout tempfile,' <blockquote> <pre>' foo  '</pre> </blockquote>'

        call lineout tempfile,' <h3> Some User &amp; Server Info </h3> '

/* This section demonstrates the use of some GOSERVE functions */
   caddr=extract('CLIENTADDR')
   if value('SREF_NODNS',,'OS2ENVIRONMENT')=1 then
      cname=caddr
   else
       cname=clientname()
   ssoft=server()
   sname=servername
   saddr=extract('SERVERADDR')
   sport=extract('SERVERPORT')

   call lineout tempfile,' <ul> '
   call lineout tempfile,' <li> Client ip address:  <code>' caddr '</code>'
   call lineout tempfile,' <li> Client name:  <code>' cname '</code>'
   call lineout tempfile,' <li> Server ip address: <code>' saddr '</code>'
   call lineout tempfile,' <li> Server port:  <code>' sport '</code>'

   call lineout tempfile,' <li> Server name:  <code>' sname '</code>'
   call lineout tempfile, ' <li> Server software:  <code>' ssoft '</code>'
  aver=sref_version()
   call lineout tempfile,' <li>  Filter version: <code> ' aver ' </code>'
   call lineout tempfile,' <li> Your privileges are: <tt> ' privset ' </tt>'
   call lineout tempfile,' </ul> '


getuse: nop
/* get some "intensity of use " statistics */
 reptime=extract('RESPONSETIME')
 numtrans=extract('TRANSACTIONS')
 whenstart=extract('LASTSTART')
 nclients=extract('CLIENTS')

   call lineout tempfile,' <h3> Use Statistics </h3> '
   call lineout tempfile,' GoServe started: ' whenstart

   call lineout tempfile,'<BR> # of transactions ' numtrans  ', avg. reponsetime = 'reptime ' sec. '

   call lineout tempfile,'<BR> Current # of clients = ' nclients

end

/* Special features (such as the HOST function) -- demonstrates the use of external calls */
 

/* if we found a GETIP, and got it's value, then lookit up */
  if optname.!GETIP<>0  then do
/* Note use of the address cmd xxx to call a OS/2 level command  */
    A=RXQUEUE('S','SESSION')    /* SINCE QUEUE MIGHT BE A THREAD'S QUEUE */
    do queued(); pull .; end                   /* flush */
    chkip=optname.!GETIP
    address cmd '@host' chkip '| rxqueue'     /* execute the command */
    parse pull hostresult                      /* get result */
    call lineout tempfile,' <h3> Look up address </h3> '
    call lineout tempfile,' <pre> ' hostresult ' </pre>'
  end


if srelite=1 then do
  call lineout tempfile,'<h3>SuperUser options:</h3>'
  call lineout tempfile,'<b>SuperUsers</b> can:<menu>'
  call lineout tempfile,'<li> <a href="/!RESET">reset parameters</a>'
  call lineout tempfile,' <li> View  <A href="/statusl?params=1">parameter settings</a>'
  call lineout tempfile,'</menu>'
end /* do */

if srelite=1 & optname.!PARAMS=1  then do
  if wordpos('SUPERUSER',translate(privset))>1 then do
    call show_params
  end
  else do
     call lineout tempfile,' Can not view/modify parameters: you do not have SuperUser privileges -- try resetting parameters first<p>'
  end /* do */
end /* do */




/* all done, write final end-of-html elements */
  call lineout tempfile,'<body> </html>'
  call lineout tempfile
  oof=stream(tempfile,'c','query size')
  foo=sref_gos('FILE ERASE TYPE text/html NAME' tempfile)
  return '200 'oof

/* ----------- */
/* get environment value. Typically, look for host-specific
value first, and then look for generic value (if no host given,
skip host-specific lookup )
vname: variable to lookup
hname0: Special instructions:
  hname0=0 -- do not look under host nickname
  hname0=1 -- do not look under default
 */
/* ------------ */
get_value: procedure expose enmadd host_nickname
parse upper arg vname,hname0
if hname0=0 then
        hname=' '
else
    hname=strip(host_nickname)

vname=strip(vname) ;
if hname<>' ' then do
   booger=strip(enmadd||vname||'.'||hname)
   aval=value(booger,,'os2environment')
   if aval<>' ' | hname0=1 Then
        return aval
end
aval=value(enmadd||vname,,'os2environment')
return aval

/********/
/* show sre-lite parameters  (maybe add "change parameters" option later)*/
show_params:

call lineout tempfile,' <hr><h3>Current parameter settings </h3> '
/* call lineout tempfile,'<form method="GET" action="/STATUSL"> <em>Click a button to change one these parameters</em>' */
ofo=''

os2e='os2environment'
call lineout tempfile,'<ul>'
params='ACCEPT_RANGE ALWAYS_GET_PRIVS CHECK_SLASHS DEFAULT_REQUIRES DEFAULTS POST_FILTER ',
       'DIR_EXCLUSION LOGIT NOT_FOUND_FILE REALM SSI_EXTENSIONS SUPERUSERS VERBOSE'
do mm=1 to words(params)
  aw=strip(word(params,mm))
  aa=value('SRELI_'||aw,,os2e)
/*  ofo='<input type="radio" name="CHANGE" value="'aw'">'*/
  Call lineout tempfile,'<li>'ofo||' '||aw '= <tt>'aa'</tt>'
end
/* now do the stems */

nsel=value('SRELI_SEL_REQUIRES.0',,os2e)
if nsel='' then nsel=0
/* ofo='<input type="radio" name="CHANGE" value="SEL_REQUIRES.0">' */
call lineout tempfile,'<li>'ofo'SEL_REQUIRES.0 = ' nsel
if nsel>0  then do
  call lineout tempfile,'<menu>'
  do mm=1 to nsel
     asel=value('SRELI_SEL_REQUIRES.'||mm,,os2e)
     /* ofo='<input type="radio" name="CHANGE" value="SEL_REQUIRES.'mm'">' */
     call lineout tempfile,'<li>'ofo'SEL_REQUIRES.'mm'= <tt>'asel'</tt>'
  end
  call lineout tempfile,'</menu>'
end


nsel=value('SRELI_ALIASES.0',,os2e)
if nsel='' then nsel=0
/* ofo='<input type="radio" name="CHANGE" value="ALIASES.0">'*/
call lineout tempfile,'<li>'ofo'ALIASES.0 = ' nsel
if nsel>0  then do
  call lineout tempfile,'<menu>'
  do mm=1 to nsel
     asel=value('SRELI_ALIASES.'||mm,,os2e)
     /*ofo='<input type="radio" name="CHANGE" value="ALIASES.'mm'">'*/
     call lineout tempfile,'<li>'ofo'ALIASES.'mm'= <tt>'asel'</tt>'
  end
  call lineout tempfile,'</menu>'
end


nsel=value('SRELI_INHOUSEIPS.0',,os2e)
if nsel='' then nsel=0
/*ofo='<input type="radio" name="CHANGE" value="INHOUSEIPS.0">'*/
call lineout tempfile,'<li>'ofo'INHOUSEIPS.0 = ' nsel
if nsel>0  then do
  call lineout tempfile,'<menu>'
  do mm=1 to nsel
     asel=value('SRELI_INHOUSEIPS.'||mm,,os2e)
     /*ofo='<input type="radio" name="CHANGE" value="INHOUSEIPS.'mm'">'*/
     call lineout tempfile,'INHOUSEIPS.'mm'= <tt>'asel'</tt>'
  end
  call lineout tempfile,'</menu>'
end


call lineout tempfile,'</ul><p>'
/* call lineout tempfile,'<input type="submit"><input type="RESET"></form><p>'*/
call lineout tempfile,'Would you like to view the <a href="/samples/srelite.doc" window="MANUAL"> sreLite manual?</a>'
call lineout tempfile,'<br>Or, return to the <a href="/">home page</a> <br>'
return 1



